﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------
	
local CreateFrame      = CreateFrame;
local InCombatLockdown = InCombatLockdown;

local anchor     = nil;
local visibility = nil;
	
-------------------------------------------------------------------------------
-- I'm not knocking anyone's code, mine is crap half the time. But OMFG I hate
-- code that abstracts abstraction to the point where it becomes all but unreadable.
-- I *hope* I've reverse engineered KTM's code accurately enough for this
-- integration to be stable. No promises.

function nUI:initKTM()
	
	if nUI.AddOn.ktm then
			
		local frame = klhtm.raidtable.instances[1].gui;
		
		if not frame.nUI_init then

			frame.nUI_init = true
				
			anchor     = CreateFrame( "Frame", "$parent_KTMAnchor", nUI.info_frame, "SecureStateHeaderTemplate" );
			visibility = CreateFrame( "Frame", "$parentVisibility", anchor, "SecureFrameTemplate" );
					
			nUI.info_frame:SetAttribute( "addchild", anchor );
			
			visibility:SetAttribute( "showstates", 1 );
			
			anchor:SetAttribute( "showstates", "5" );
			anchor:SetAttribute( "addchild", visibility );
			anchor:SetAttribute( "state", InCombatLockdown() and 1 or 0 );
			
			anchor:SetScript( "OnShow", 
				function()
					anchor:SetAttribute( "state", InCombatLockdown() and 1 or 0 );
				end
			);
			
			
			nUI:addInfoMode( "KTM", 5 );
					
			frame:SetParent( visibility );
			frame:SetScale( 1 );
			
			-- move the options and master target to the info selection button so
			-- the user has easy access to them
			
			frame.header.options:ClearAllPoints();
			frame.header.options:SetParent( anchor );
			frame.header.options:SetScale( 0.8 );
			frame.header.options:SetPoint( "BOTTOM", nUI.info_frame.button, "BOTTOMRIGHT", 0, 0 )
			frame.header.options:Show();
			
			frame.header.setmt:ClearAllPoints();
			frame.header.setmt:SetParent( anchor );
			frame.header.setmt:SetScale( 0.8 );
			frame.header.setmt:SetPoint( "BOTTOM", nUI.info_frame.button, "BOTTOMLEFT", 5, 0 )
			frame.header.setmt:Show();
			
			-- the KTM header is wasted space now, so lose it
			
			frame.header:Hide();
			frame.header.Show = function() end;
			frame.header.Hide = function() end;
			
			-- posistion the threat table over the stats frame
			
			frame.table:ClearAllPoints();
			frame.table:SetScale( (nUI.info_frame.stats:GetWidth()-6) / frame.table:GetWidth() );
			frame.table:SetPoint( "TOPLEFT", nUI.info_frame.stats, "TOPLEFT", 0, 0 );
			frame.table:SetPoint( "BOTTOMLEFT", nUI.info_frame.stats, "BOTTOMLEFT", 0, 0 );
			frame.table:SetBackdropColor( 0, 0, 0, 0 );
			frame.table:SetBackdropBorderColor( 0, 0, 0, 0 );
			frame.table:Show();
			frame.table.Show = function() end;
			frame.table.Hide = function() end;
			
			anchor:SetScript( "OnEvent", function() nUI:klhEvent(); end );
			anchor:RegisterEvent( "PLAYER_REGEN_ENABLED" );
			anchor:RegisterEvent( "PLAYER_REGEN_DISABLED" );
			anchor:RegisterEvent( "PET_ATTACK_START" );
			anchor:RegisterEvent( "PET_ATTACK_STOP" );
		end
	end
end

-------------------------------------------------------------------------------

function nUI:klhEvent()
	
	if event == "PLAYER_REGEN_DISABLED" or event == "PET_ATTACK_START" then
			
		anchor:SetAttribute( "state", 1 );
			
	elseif event == "PLAYER_REGEN_ENABLED" or (event == "PET_ATTACK_STOP" and not InCombatLockdown()) then

		anchor:SetAttribute( "state", 0 );

	end
end
