﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------

-- basic layout

nUI_PetBarLayout =
{
	btn_size = 39,
	gap      = 1,
	anchor   = "BOTTOM",
	xOfs     = 0,
	yOfs     = 187,
};

-- the anchor frame and bar frames

nUI_PetBar = CreateFrame( "Frame", "nUI_PetBar", nUI_Dashboard );

nUI_PetBar:SetBackdrop(
	{
		bgFile   = "Interface\\AddOns\\nUI\\Art\\nUI_BevelboxBg.blp", 
		edgeFile = "Interface\\AddOns\\nUI\\Art\\nUI_BevelboxBorder.blp", 
		tile     = true, 
		tileSize = 1, 
		edgeSize = 12, 
		insets   = {left = 0, right = 0, top = 0, bottom = 0},
	}
);

-- button initialization

nUI_PetBar.PetButtons = {};
nUI_PetBar.ShapeshiftButtons = {};
nUI_PetBar.PossessButtons = {};

for i=1,10 do
	
	nUI_PetBar.PetButtons[i]        = _G["PetActionButton"..i];
	nUI_PetBar.ShapeshiftButtons[i] = _G["ShapeshiftButton"..i];
	nUI_PetBar.PossessButtons[i]    = _G["PossessButton"..i];

	local button = nUI_PetBar.PetButtons[i];
	
	-- some tweaks to the pet bar button
	
	if button then
		
		local auto_cast = _G["PetActionButton"..i.."AutoCast"];
		local normal2   = _G["PetActionButton"..i.."NormalTexture2"];
		
		button:SetNormalTexture( "" );
		auto_cast:SetAlpha( 0.05 );
		normal2:SetAlpha( 0 );
		
	end
end

-- manage the layout of the Pet Bar

nUI_PetBar:SetScript( "OnEvent", function() nUI_PetBar:layoutFrame(); end );
nUI_PetBar:RegisterEvent( "VARIABLES_LOADED" );
nUI_PetBar:RegisterEvent( "DISPLAY_SIZE_CHANGED" );

nUI_PetBar.layoutFrame = function()
				
	nUI:setScale();
				
	local btn_size    = nUI_PetBarLayout.btn_size * nUI.scale;
	local btn_gap     = nUI_PetBarLayout.gap * nUI.scale;
	local last_button = {};
	
	nUI_PetBar:SetFrameStrata( nUI_Dashboard:GetFrameStrata() );
	nUI_PetBar:SetFrameLevel( nUI_Dashboard:GetFrameLevel()+1 );
	
	nUI_PetBar:SetScale( 1.0 / nUI.scale );
	nUI_PetBar:SetHeight( btn_size * 1.2 );
	nUI_PetBar:SetWidth( (btn_size * 10) + (btn_gap * 9) + btn_size * 0.2 );
	nUI_PetBar:SetPoint( nUI_PetBarLayout.anchor, nUI_Dashboard, "CENTER", nUI_PetBarLayout.xOfs * nUI.scale, nUI_PetBarLayout.yOfs * nUI.scale );
	
	for i=1,10 do
		
		local button = {};
		
		button[1] = nUI_PetBar.PetButtons[i];
		button[2] = nUI_PetBar.ShapeshiftButtons[i];
		button[3] = nUI_PetBar.PossessButtons[i];

		for j=1,3 do
			
			if button[j] then
	
				nUI:debugMsg( button[j]:GetName()..": new size = "..btn_size..", actual = "..button[j]:GetWidth()..", scale = "..(btn_size/button[j]:GetWidth()) );
				
				button[j]:ClearAllPoints();
				button[j]:SetFrameStrata( nUI_PetBar:GetFrameStrata() );
				button[j]:SetFrameLevel( nUI_PetBar:GetFrameLevel()+1 );
				button[j]:SetScale( btn_size / button[j]:GetWidth() );
				
				if i == 1 then button[j]:SetPoint( "TOPLEFT", nUI_PetBar, "TOPLEFT", btn_size * 0.1, -btn_size * 0.1 );
				else button[j]:SetPoint( "TOPLEFT", last_button[j], "TOPRIGHT", btn_gap, 0 );
				end
		
				last_button[j] = button[j];
			end
		end
	end		
end